note
	description: "Define a type of possible index type that occur in the tables we are interested in."
	date: "$Date: 2022-12-07 20:49:09 +0000 (Wed, 07 Dec 2022) $"
	revision: "$Revision: 106429 $"

class
	PE_SEMANTICS

inherit

	PE_INDEX_BASE
		rename
			make as make_base
		redefine
			get_index_shift,
			has_index_overflow
		end

create
	make_with_tag_and_index,
	make

feature {NONE} -- Initialization

	make
		do
		end

feature -- Enum: tags

	TagBits: INTEGER = 1
	Event: INTEGER = 0
	Property: INTEGER = 1

feature -- Operations

	get_index_shift: INTEGER
		do
			Result := tagbits
		end

	has_index_overflow (a_sizes: ARRAY [NATURAL_64]): BOOLEAN
		do
			Result := large(a_sizes[{PE_TABLES}.tEvent.value.to_integer_32 + 1].to_natural_32) or else
					  large(a_sizes[{PE_TABLES}.tProperty.value.to_integer_32 + 1].to_natural_32)
		end

end
